## ros-humble-rcl 5.3.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl)

find_package(ament_cmake_ros REQUIRED)

find_package(rcl_interfaces REQUIRED)
find_package(rcl_logging_interface REQUIRED)
find_package(rcl_yaml_param_parser REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(tracetools REQUIRED)

include(cmake/rcl_set_symbol_visibility_hidden.cmake)
include(cmake/get_default_rcl_logging_implementation.cmake)
get_default_rcl_logging_implementation(RCL_LOGGING_IMPL)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(${PROJECT_NAME}_sources
  src/rcl/arguments.c
  src/rcl/client.c
  src/rcl/common.c
  src/rcl/context.c
  src/rcl/domain_id.c
  src/rcl/event.c
  src/rcl/expand_topic_name.c
  src/rcl/graph.c
  src/rcl/guard_condition.c
  src/rcl/init.c
  src/rcl/init_options.c
  src/rcl/lexer.c
  src/rcl/lexer_lookahead.c
  src/rcl/localhost.c
  src/rcl/logging_rosout.c
  src/rcl/logging.c
  src/rcl/log_level.c
  src/rcl/network_flow_endpoints.c
  src/rcl/node.c
  src/rcl/node_options.c
  src/rcl/publisher.c
  src/rcl/remap.c
  src/rcl/node_resolve_name.c
  src/rcl/rmw_implementation_identifier_check.c
  src/rcl/security.c
  src/rcl/service.c
  src/rcl/subscription.c
  src/rcl/time.c
  src/rcl/timer.c
  src/rcl/validate_enclave_name.c
  src/rcl/validate_topic_name.c
  src/rcl/wait.c
)

add_library(${PROJECT_NAME} ${${PROJECT_NAME}_sources})
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
# specific order: dependents before dependencies
ament_target_dependencies(${PROJECT_NAME}
  "rcl_interfaces"
  "rcl_logging_interface"
  "rcl_yaml_param_parser"
  "rcutils"
  "rmw"
  "rmw_implementation"
  ${RCL_LOGGING_IMPL}
  "rosidl_runtime_c"
  "tracetools"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCL_BUILDING_DLL")
rcl_set_symbol_visibility_hidden(${PROJECT_NAME} LANGUAGE "C")

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

# rcl_lib_dir is passed as APPEND_LIBRARY_DIRS for each ament_add_gtest call so
# the librcl that they link against is on the library path.
# This is especially important on Windows.
# This is overwritten each loop, but which one it points to doesn't really matter.
set(rcl_lib_dir "$<TARGET_FILE_DIR:${PROJECT_NAME}>")

# Export old-style CMake variables
ament_export_include_directories("include/${PROJECT_NAME}")
ament_export_libraries(${PROJECT_NAME})
# Export modern CMake targets
ament_export_targets(${PROJECT_NAME})

# specific order: dependents before dependencies
ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl_interfaces)
ament_export_dependencies(rcl_logging_interface)
ament_export_dependencies(rcl_yaml_param_parser)
ament_export_dependencies(rmw_implementation)
ament_export_dependencies(rmw)
ament_export_dependencies(rcutils)
ament_export_dependencies(${RCL_LOGGING_IMPL})
ament_export_dependencies(rosidl_runtime_c)
ament_export_dependencies(tracetools)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  add_subdirectory(test)
endif()

ament_package(CONFIG_EXTRAS "rcl-extras.cmake")

install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)
install(
  DIRECTORY include/
  DESTINATION include/${PROJECT_NAME}
)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(launch_testing_ament_cmake REQUIRED)

find_package(mimick_vendor REQUIRED)
find_package(test_msgs REQUIRED)

find_package(mimick_vendor REQUIRED)

find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

find_package(osrf_testing_tools_cpp REQUIRED)

get_target_property(memory_tools_ld_preload_env_var
  osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_VARIABLE)

include(cmake/rcl_add_custom_executable.cmake)
include(cmake/rcl_add_custom_gtest.cmake)
include(cmake/rcl_add_custom_launch_test.cmake)

set(extra_lib_dirs "${rcl_lib_dir}")
add_definitions(-DTEST_RESOURCES_DIRECTORY="${CMAKE_CURRENT_SOURCE_DIR}/resources")

set(DISTRIBUTION "Unknown")
if("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
  # If we are on Linux, look for /etc/os-release, which has "key=value" items.
  # Parse those items, looking for a key named "id" (case-insensitive), and
  # if we find it, set DISTRIBUTION to that value.  That gives us some idea
  # of which Linux distribution we are on.
  if(EXISTS "/etc/os-release")
    file(STRINGS "/etc/os-release" OS_RELEASE)
    foreach(line ${OS_RELEASE})
      string(REGEX REPLACE "^(.*)=.*" "\\1" key "${line}")
      string(TOLOWER "${key}" key)
      if("${key}" STREQUAL "id")
        string(REGEX REPLACE "^.*=(.*)" "\\1" DISTRIBUTION "${line}")
        string(TOLOWER "${DISTRIBUTION}" DISTRIBUTION)
        break()
      endif()
    endforeach()
  endif()
endif()

# finding gtest once in the highest scope
# prevents finding it repeatedly in each local scope
ament_find_gtest()

macro(test_target)
  find_package(${rmw_implementation} REQUIRED)
  test_target_function()
endmacro()

function(test_target_function)
  message(STATUS "Creating tests for '${rmw_implementation}'")
  set(rmw_implementation_env_var RMW_IMPLEMENTATION=${rmw_implementation})

  # Gtests

  rcl_add_custom_gtest(test_client${target_suffix}
    SRCS rcl/test_client.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_time${target_suffix}
    SRCS rcl/test_time.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_timer${target_suffix}
    SRCS rcl/test_timer.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_context${target_suffix}
    SRCS rcl/test_context.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_get_node_names${target_suffix}
    SRCS rcl/test_get_node_names.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_lexer${target_suffix}
    SRCS rcl/test_lexer.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_lexer_lookahead${target_suffix}
    SRCS rcl/test_lexer_lookahead.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_graph${target_suffix}
    SRCS rcl/test_graph.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
    TIMEOUT 120
  )

  rcl_add_custom_gtest(test_info_by_topic${target_suffix}
    SRCS rcl/test_info_by_topic.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_count_matched${target_suffix}
    SRCS rcl/test_count_matched.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_get_actual_qos${target_suffix}
    SRCS rcl/test_get_actual_qos.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "test_msgs" "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_init${target_suffix}
    SRCS rcl/test_init.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  # RHEL does not support mimick's inject_on_return functionality, which
  # causes test_node to segfault when it runs.  Since RHEL is not a Tier 1
  # platform, just disable the test since we are covering it elsewhere.
  if(
    "${DISTRIBUTION}" STREQUAL "\"centos\"" OR
    "${DISTRIBUTION}" STREQUAL "\"almalinux\"")
    set(gtest_filter_env_var "GTEST_FILTER=-TestNodeFixture__*.test_rcl_node_init_with_internal_errors")
  else()
    set(gtest_filter_env_var "")
  endif()
  rcl_add_custom_gtest(test_node${target_suffix}
    SRCS rcl/test_node.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var} ${gtest_filter_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
    TIMEOUT 240  # Large timeout to wait for fault injection tests
  )

  rcl_add_custom_gtest(test_arguments${target_suffix}
    SRCS rcl/test_arguments.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES "osrf_testing_tools_cpp" "rcpputils"
  )

  rcl_add_custom_gtest(test_remap${target_suffix}
    SRCS rcl/test_remap.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_remap_integration${target_suffix}
    SRCS rcl/test_remap_integration.cpp
    TIMEOUT 200
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_guard_condition${target_suffix}
    SRCS rcl/test_guard_condition.cpp
    ENV ${rmw_implementation_env_var} ${memory_tools_ld_preload_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_publisher${target_suffix}
    SRCS rcl/test_publisher.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} mimick
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_publisher_wait_all_ack${target_suffix}
    SRCS rcl/test_publisher_wait_all_ack.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation}
      "osrf_testing_tools_cpp"
      "rcpputils"
      "rcutils"
      "rosidl_runtime_c"
      "test_msgs"
  )

  rcl_add_custom_gtest(test_service${target_suffix}
    SRCS rcl/test_service.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_subscription${target_suffix}
    SRCS rcl/test_subscription.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick wait_for_entity_helpers
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
    TIMEOUT 120
  )
  # TODO(asorbini) Enable message timestamp tests for rmw_connextdds on Windows
  # once clock incompatibilities are resolved.
  if(rmw_implementation STREQUAL "rmw_fastrtps_cpp" OR
    rmw_implementation STREQUAL "rmw_fastrtps_dynamic_cpp" OR
    (rmw_implementation STREQUAL "rmw_connextdds" AND NOT WIN32))
    message(STATUS "Enabling message timestamp test for ${rmw_implementation}")
    target_compile_definitions(test_subscription${target_suffix}
      PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1" "RMW_RECEIVED_TIMESTAMP_SUPPORTED=1")
    target_compile_definitions(test_service${target_suffix}
      PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1" "RMW_RECEIVED_TIMESTAMP_SUPPORTED=1")
  else()
    if(rmw_implementation STREQUAL "rmw_cyclonedds_cpp")
      message(STATUS "Enabling only source timestamp test for ${rmw_implementation}")
      target_compile_definitions(test_subscription${target_suffix}
        PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1")
      target_compile_definitions(test_service${target_suffix}
        PUBLIC "RMW_TIMESTAMPS_SUPPORTED=1")
    else()
      message(STATUS "Disabling message timestamp test for ${rmw_implementation}")
    endif()
  endif()

  rcl_add_custom_gtest(test_events${target_suffix}
    SRCS rcl/test_events.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_wait${target_suffix}
    SRCS rcl/test_wait.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp"
  )

  rcl_add_custom_gtest(test_logging_rosout${target_suffix}
    SRCS rcl/test_logging_rosout.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "rcl_interfaces"
  )

  rcl_add_custom_gtest(test_namespace${target_suffix}
    SRCS test_namespace.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME}
    AMENT_DEPENDENCIES ${rmw_implementation} "osrf_testing_tools_cpp" "test_msgs"
  )

  rcl_add_custom_gtest(test_rmw_impl_id_check_func${target_suffix}
    SRCS rcl/test_rmw_impl_id_check_func.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    LIBRARIES ${PROJECT_NAME} mimick
    AMENT_DEPENDENCIES ${rmw_implementation}
  )

  rcl_add_custom_gtest(test_network_flow_endpoints${target_suffix}
    SRCS rcl/test_network_flow_endpoints.cpp
    ENV ${rmw_implementation_env_var}
    APPEND_LIBRARY_DIRS ${extra_lib_dirs}
    INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../src/rcl/
    LIBRARIES ${PROJECT_NAME} mimick

=== debian/changelog ===
ros-humble-rcl (5.3.4-3jammy) jammy; urgency=high

  * Implement rcl_clock_time_started (#1021 <https://github.com/ros2/rcl/issues/1021>) (#1078 <https://github.com/ros2/rcl/issues/1078>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 17 Jul 2023 00:00:00 -0000

ros-humble-rcl (5.3.3-3jammy) jammy; urgency=high

  * user defined allocator should be used for rosout publisher. (#1044 <https://github.com/ros2/rcl/issues/1044>) (#1045 <https://github.com/ros2/rcl/issues/1045>)
  * avoid unnecessary copy for rcutils_char_array_vsprintf. (#1035 <https://github.com/ros2/rcl/issues/1035>) (#1039 <https://github.com/ros2/rcl/issues/1039>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 25 Apr 2023 00:00:00 -0000

ros-humble-rcl (5.3.2-3jammy) jammy; urgency=high

  * fixed rcl_wait return error when timer cancelled (#1003 <https://github.com/ros2/rcl/issues/1003>) (#1006 <https://github.com/ros2/rcl/issues/1006>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 08 Sep 2022 00:00:00 -0000

ros-humble-rcl (5.3.1-3jammy) jammy; urgency=high

  * Fix buffer overflow in argument parsing caused by lexer returning length beyond length of string (#979 <https://github.com/ros2/rcl/issues/979>)
  * Fix leak in test_subscription_content_filter_options.cpp (#978 <https://github.com/ros2/rcl/issues/978>)
  * Contributors: Shane Loretz

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 26 Apr 2022 00:00:00 -0000

ros-humble-rcl (5.3.0-3jammy) jammy; urgency=high

  * add content-filtered-topic interfaces (#894 <https://github.com/ros2/rcl/issues/894>)
  * Contributors: Chen Lihui

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 05 Apr 2022 00:00:00 -0000

ros-humble-rcl (5.2.1-3jammy) jammy; urgency=high

  * Add additional null check for timer argument (#973 <https://github.com/ros2/rcl/issues/973>)
  * Contributors: NoyZuberi

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 31 Mar 2022 00:00:00 -0000

ros-humble-rcl (5.2.0-3jammy) jammy; urgency=high

  * Allow forward slashes within a parameter name rule in argument parsing (#860 <https://github.com/ros2/rcl/issues/860>)
  * Suppress false positive from clang-tidy (#951 <https://github.com/ros2/rcl/issues/951>)
  * Fix missing terminating 0 in rcl_context_impl_t.argv (#969 <https://github.com/ros2/rcl/issues/969>)
  * test_publisher_wait_all_ack depends on rcpputils (#968 <https://github.com/ros2/rcl/issues/968>)
  * Micro-optimizations in rcl (#965 <https://github.com/ros2/rcl/issues/965>)
  * If timer canceled, rcl_timer_get_time_until_next_call returns TIMER_CANCELED (#963 <https://github.com/ros2/rcl/issues/963>)
  * Contributors: Chris Lalancette, Haowei Wen, Ivan Santiago Paunovic, Shane Loretz, William Woodall, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 24 Mar 2022 00:00:00 -0000

ros-humble-rcl (5.1.0-3jammy) jammy; urgency=high

  * Add Events Executor (#839 <https://github.com/ros2/rcl/issues/839>)
  * Remove fastrtps customization on test_events (#960 <https://github.com/ros2/rcl/issues/960>)
  * Add client/service QoS getters (#941 <https://github.com/ros2/rcl/issues/941>)
  * introduce ROS_DISABLE_LOAN_MSG to disable can_loan_messages. (#949 <https://github.com/ros2/rcl/issues/949>)
  * Install includes it include/${PROJECT_NAME} (#959 <https://github.com/ros2/rcl/issues/959>)
  * Contributors: Miguel Company, Shane Loretz, Tomoya Fujita, iRobot ROS, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 01 Mar 2022 00:00:00 -0000

ros-humble-rcl (5.0.1-3jammy) jammy; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 14 Jan 2022 00:00:00 -0000

ros-humble-rcl (5.0.0-3jammy) jammy; urgency=high

  * Make rcl_difference_times args const (#955 <https://github.com/ros2/rcl/issues/955>)
  * Update inject_on_return test skipping logic (#953 <https://github.com/ros2/rcl/issues/953>)
  * Fix jump callbacks being called when zero time jump thresholds used (#948 <https://github.com/ros2/rcl/issues/948>)
  * Only change the default logger level if default_logger_level is set (#943 <https://github.com/ros2/rcl/issues/943>)
  * Add Library for wait_for_entity_helpers to deduplicate compilation (#942 <https://github.com/ros2/rcl/issues/942>)
  * Increase Windows timeout 15 -> 25 ms (#940 <https://github.com/ros2/rcl/issues/940>)
  * test should check specified number of entities. (#935 <https://github.com/ros2/rcl/issues/935>)
  * Contributors: Jafar Abdi, Scott K Logan, Shane Loretz, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 14 Dec 2021 00:00:00 -0000

ros-humble-rcl (4.0.0-3jammy) jammy; urgency=high

  * Fix up documentation build for rcl when using rosdoc2 (#932 <https://github.com/ros2/rcl/issues/932>)
  * Include rmw_event_t instead of forward declaring it (#933 <https://github.com/ros2/rcl/issues/933>)
  * Contributors: Michel Hidalgo

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 16 Sep 2021 00:00:00 -0000

ros-humble-rcl (3.2.0-3jammy) jammy; urgency=high

  * Add rcl_publisher_wait_for_all_acked support. (#913 <https://github.com/ros2/rcl/issues/913>)
  * Add tracing instrumentation for rcl_take. (#930 <https://github.com/ros2/rcl/issues/930>)
  * Fix #include in C++ typesupport example in rcl_subscription_init docblock. (#927 <https://github.com/ros2/rcl/issues/927>)
  * Update includes after rcutils/get_env.h deprecation. (#917 <https://github.com/ros2/rcl/issues/917>)
  * Use proper rcl_logging return value type and compare to constant. (#916 <https://github.com/ros2/rcl/issues/916>)
  * Contributors: Barry Xu, Christophe Bedard

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 02 Sep 2021 00:00:00 -0000

ros-humble-rcl (3.1.2-3jammy) jammy; urgency=high

  * Fix up test_network_flow_endpoints. (#912 <https://github.com/ros2/rcl/issues/912>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 26 Apr 2021 00:00:00 -0000



=== debian/control ===
Source: ros-humble-rcl
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-cmake-ros, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-launch <!nocheck>, ros-humble-launch-testing <!nocheck>, ros-humble-launch-testing-ament-cmake <!nocheck>, ros-humble-mimick-vendor <!nocheck>, ros-humble-osrf-testing-tools-cpp <!nocheck>, ros-humble-rcl-interfaces, ros-humble-rcl-logging-interface, ros-humble-rcl-logging-spdlog, ros-humble-rcl-yaml-param-parser, ros-humble-rcpputils <!nocheck>, ros-humble-rcutils, ros-humble-rmw <!nocheck>, ros-humble-rmw-implementation, ros-humble-rmw-implementation-cmake <!nocheck>, ros-humble-rosidl-runtime-c, ros-humble-test-msgs <!nocheck>, ros-humble-tracetools, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-rcl-interfaces, ros-humble-rcl-logging-interface, ros-humble-rcl-logging-spdlog, ros-humble-rcl-yaml-param-parser, ros-humble-rcutils, ros-humble-rmw, ros-humble-rmw-implementation, ros-humble-rosidl-runtime-c, ros-humble-tracetools, ros-humble-ros-workspace
Description: The ROS client library common implementation.
 This package contains an API which builds on the ROS middleware API and is optionally built upon by the other ROS client libraries.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rcl//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-rcl 5.3.8

=== debian/changelog ===
ros-humble-rcl (5.3.8-1bookworm) bookworm; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 14 May 2024 16:00:00 -0000

ros-humble-rcl (5.3.7-1bookworm) bookworm; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Jan 2024 16:00:00 -0000

ros-humble-rcl (5.3.6-1bookworm) bookworm; urgency=high

  * Set disable loan to on by default. (backport #1110 <https://github.com/ros2/rcl/issues/1110>) (#1116 <https://github.com/ros2/rcl/issues/1116>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Sun, 12 Nov 2023 16:00:00 -0000

ros-humble-rcl (5.3.5-1bookworm) bookworm; urgency=high

  * rcl_send_response returns RCL_RET_TIMEOUT. (backport #1048 <https://github.com/ros2/rcl/issues/1048>) (#1091 <https://github.com/ros2/rcl/issues/1091>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 18 Sep 2023 16:00:00 -0000

ros-humble-rcl (5.3.4-1bookworm) bookworm; urgency=high

  * Implement rcl_clock_time_started (#1021 <https://github.com/ros2/rcl/issues/1021>) (#1078 <https://github.com/ros2/rcl/issues/1078>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Sun, 16 Jul 2023 16:00:00 -0000

ros-humble-rcl (5.3.3-1bookworm) bookworm; urgency=high

  * user defined allocator should be used for rosout publisher. (#1044 <https://github.com/ros2/rcl/issues/1044>) (#1045 <https://github.com/ros2/rcl/issues/1045>)
  * avoid unnecessary copy for rcutils_char_array_vsprintf. (#1035 <https://github.com/ros2/rcl/issues/1035>) (#1039 <https://github.com/ros2/rcl/issues/1039>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 24 Apr 2023 16:00:00 -0000

ros-humble-rcl (5.3.2-1bookworm) bookworm; urgency=high

  * fixed rcl_wait return error when timer cancelled (#1003 <https://github.com/ros2/rcl/issues/1003>) (#1006 <https://github.com/ros2/rcl/issues/1006>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 07 Sep 2022 16:00:00 -0000

ros-humble-rcl (5.3.1-1bookworm) bookworm; urgency=high

  * Fix buffer overflow in argument parsing caused by lexer returning length beyond length of string (#979 <https://github.com/ros2/rcl/issues/979>)
  * Fix leak in test_subscription_content_filter_options.cpp (#978 <https://github.com/ros2/rcl/issues/978>)
  * Contributors: Shane Loretz

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Apr 2022 16:00:00 -0000

ros-humble-rcl (5.3.0-1bookworm) bookworm; urgency=high

  * add content-filtered-topic interfaces (#894 <https://github.com/ros2/rcl/issues/894>)
  * Contributors: Chen Lihui

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 04 Apr 2022 16:00:00 -0000

ros-humble-rcl (5.2.1-1bookworm) bookworm; urgency=high

  * Add additional null check for timer argument (#973 <https://github.com/ros2/rcl/issues/973>)
  * Contributors: NoyZuberi

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 30 Mar 2022 16:00:00 -0000

ros-humble-rcl (5.2.0-1bookworm) bookworm; urgency=high

  * Allow forward slashes within a parameter name rule in argument parsing (#860 <https://github.com/ros2/rcl/issues/860>)
  * Suppress false positive from clang-tidy (#951 <https://github.com/ros2/rcl/issues/951>)
  * Fix missing terminating 0 in rcl_context_impl_t.argv (#969 <https://github.com/ros2/rcl/issues/969>)
  * test_publisher_wait_all_ack depends on rcpputils (#968 <https://github.com/ros2/rcl/issues/968>)
  * Micro-optimizations in rcl (#965 <https://github.com/ros2/rcl/issues/965>)
  * If timer canceled, rcl_timer_get_time_until_next_call returns TIMER_CANCELED (#963 <https://github.com/ros2/rcl/issues/963>)
  * Contributors: Chris Lalancette, Haowei Wen, Ivan Santiago Paunovic, Shane Loretz, William Woodall, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Wed, 23 Mar 2022 16:00:00 -0000

ros-humble-rcl (5.1.0-1bookworm) bookworm; urgency=high

  * Add Events Executor (#839 <https://github.com/ros2/rcl/issues/839>)
  * Remove fastrtps customization on test_events (#960 <https://github.com/ros2/rcl/issues/960>)
  * Add client/service QoS getters (#941 <https://github.com/ros2/rcl/issues/941>)
  * introduce ROS_DISABLE_LOAN_MSG to disable can_loan_messages. (#949 <https://github.com/ros2/rcl/issues/949>)
  * Install includes it include/${PROJECT_NAME} (#959 <https://github.com/ros2/rcl/issues/959>)
  * Contributors: Miguel Company, Shane Loretz, Tomoya Fujita, iRobot ROS, mauropasse

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 28 Feb 2022 16:00:00 -0000

ros-humble-rcl (5.0.1-1bookworm) bookworm; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 13 Jan 2022 16:00:00 -0000

ros-humble-rcl (5.0.0-1bookworm) bookworm; urgency=high

  * Make rcl_difference_times args const (#955 <https://github.com/ros2/rcl/issues/955>)
  * Update inject_on_return test skipping logic (#953 <https://github.com/ros2/rcl/issues/953>)
  * Fix jump callbacks being called when zero time jump thresholds used (#948 <https://github.com/ros2/rcl/issues/948>)
  * Only change the default logger level if default_logger_level is set (#943 <https://github.com/ros2/rcl/issues/943>)
  * Add Library for wait_for_entity_helpers to deduplicate compilation (#942 <https://github.com/ros2/rcl/issues/942>)
  * Increase Windows timeout 15 -> 25 ms (#940 <https://github.com/ros2/rcl/issues/940>)
  * test should check specified number of entities. (#935 <https://github.com/ros2/rcl/issues/935>)
  * Contributors: Jafar Abdi, Scott K Logan, Shane Loretz, Tomoya Fujita

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 13 Dec 2021 16:00:00 -0000

ros-humble-rcl (4.0.0-1bookworm) bookworm; urgency=high

  * Fix up documentation build for rcl when using rosdoc2 (#932 <https://github.com/ros2/rcl/issues/932>)
  * Include rmw_event_t instead of forward declaring it (#933 <https://github.com/ros2/rcl/issues/933>)
  * Contributors: Michel Hidalgo



## ros-humble-rcl 5.3.9

=== debian/changelog ===
ros-humble-rcl (5.3.9-1bookworm) bookworm; urgency=high

  * Generate version header using ament_generate_version_header(..) (backport #1141 <https://github.com/ros2/rcl/issues/1141>) (#1145 <https://github.com/ros2/rcl/issues/1145>)
  * Contributors: mergify[bot]

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 25 Jul 2024 16:00:00 -0000

=== debian/control ===
Source: ros-humble-rcl
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake-gen-version-h, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-cmake-ros, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-launch <!nocheck>, ros-humble-launch-testing <!nocheck>, ros-humble-launch-testing-ament-cmake <!nocheck>, ros-humble-mimick-vendor <!nocheck>, ros-humble-osrf-testing-tools-cpp <!nocheck>, ros-humble-rcl-interfaces, ros-humble-rcl-logging-interface, ros-humble-rcl-logging-spdlog, ros-humble-rcl-yaml-param-parser, ros-humble-rcpputils <!nocheck>, ros-humble-rcutils, ros-humble-rmw <!nocheck>, ros-humble-rmw-implementation, ros-humble-rmw-implementation-cmake <!nocheck>, ros-humble-rosidl-runtime-c, ros-humble-test-msgs <!nocheck>, ros-humble-tracetools, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-rcl-interfaces, ros-humble-rcl-logging-interface, ros-humble-rcl-logging-spdlog, ros-humble-rcl-yaml-param-parser, ros-humble-rcutils, ros-humble-rmw, ros-humble-rmw-implementation, ros-humble-rosidl-runtime-c, ros-humble-tracetools, ros-humble-ros-workspace
Description: The ROS client library common implementation.
 This package contains an API which builds on the ROS middleware API and is optionally built upon by the other ROS client libraries.

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rcl//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rcl//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-rcl//opt/ros/humble/opt/rcl/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
